import { App } from 'vue';
import { ComputedRef } from 'vue';
import { Ref } from 'vue';

declare interface ABorderProps {
    flat?: boolean;
    bordered?: boolean;
    square?: boolean;
}

declare interface AFoundationDesign {
    square?: boolean;
    flat?: boolean;
    bordered?: boolean;
    btn?: {
        kind?: 'flat' | 'outline' | 'unelevated' | 'push' | 'standard';
        size?: 'xs' | 'sm' | 'md' | 'lg' | 'xl';
        square?: boolean;
        glossy?: boolean;
    };
}

export declare function AugmentQuasarPlugin(app: App, options: AugmentQuasarPluginOptions): void;

declare interface AugmentQuasarPluginOptions {
    design?: string;
    designs?: Record<string, AFoundationDesign>;
}

declare interface FoundationState {
}

export declare const foundationState: FoundationState;

export declare function useBorderProps(props: ABorderProps, design?: string): ComputedRef<ABorderProps>;

export declare const useFoundation: () => UseFoundationReturn;

declare interface UseFoundationReturn {
    design: Ref<string>;
    designs: Record<string, AFoundationDesign & {
        btnKindAttrs?: ComputedRef<{
            flat?: boolean;
            outline?: boolean;
            unelevated?: boolean;
            push?: boolean;
        }>;
    }>;
}

export { }
